Subject: [bug?] renamed file loses changes in merge.

From: Mauro Condarelli <[email-masked]>
Date: Tue, 24 Feb 2015 16:33:42 +0100

I'm unsure it is a bug or a misuse on my part, but:

Situation:

There are two distinct repositories (upstream & local), local is a fork of upstream (at tag "v3.7").
Both repositories were modified (upstream has delivered new version with tag "v3.7.1").
I need to incorporate local changes into the new upstream release.

I did the following:

git clone upstream
git checkout v3.7.1 -b v3.7.1_local                       (I do not want anything later than that)
git remote add local ../local/.git
git fetch local
git merge local/current
... resolve conflicts ...
git ad --all
git commit -m ...

At this point I discovered that one specific file:
was renamed in upstream
was changed in local

What I have on my workspace is the *renamed* file *without* the modifications from local.

Is this the normal behavior?
If so I fail to understand the rationale behind it; I would expect git to apply changes to the renamed file.

Thanks in Advance
Mauro